UNIT analyze;

INTERFACE

USES opcodes,putexpr;

var
	histo: array[opcode] of longint;
	cmd: opcode;

	procedure tabulate;

IMPLEMENTATION

	procedure tabulate;
	var
		rate,total: real;
		totalsize: longint;
		cc: integer;
		spaces: string;
		procedure putstats(spaces:string);
		begin {putstats}
			rate:= histo[cmd]/total;
			write(spaces);
			write(opstr[cmd]:opstrsize,' ',
											histo[cmd]:totalsize,' [',rate:4:2,']')
		end {putstats};
	begin {analyze}
		total:= 0;
		spaces:= '   ';
		for cmd:= Low(opcode) to High(opcode) do
			total:= total + histo[cmd];
		totalsize:= Trunc( ln(total)/ln(10) )+1;
		cmd:= Low(opcode);
		while cmd < High(opcode) do
			begin
				putstats('');
				if cmd < High(opcode) then
					begin
						cmd:= Succ(cmd);
						putstats(spaces);
						if cmd < High(opcode) then
							begin
								cmd:= Succ(cmd);
								putstats(spaces);
							end
					end;
					writeln;
					if cmd < High(opcode) then
						cmd:= Succ(cmd)
			end {while};
		putsepr('');
		writeln('total machine cycles = ',total:totalsize:0)
	end {analyze};

BEGIN

	{ initialize opcode histogram }

	for cmd:= Low(opcode) to High(opcode) do
		histo[opcode(cmd)]:= 0

END.
