{*****************************************************************************}
{*                          Bernoullische Zahlen                             *}
{*                          --------------------                             *}
{*  Das Programm berechnet die ersten N Bernoullischen Zahlen mittels einer  *}
{*  Rekursionsformel. Die Ausgabe kann wahlweise zustzlich zum Bildschirm   *}
{*  noch in eine Disketten-Datei geschrieben werden.                         *}
{*                                                                           *}
{*---------------------------------------------------------------------------*}
{*  Autor              : C. Sperr                                            *}
{*  Datum              : 08.07.87                                            *}
{*  Letzte Revision    : 20.07.93                                            *}
{*****************************************************************************}

PROGRAM Bernoullische_Zahlen;

USES CRT, InfInt;

{$I InfInt.BIB}

CONST kmax = 300;

VAR Zaehler : ARRAY[0..kmax] OF PInfInt;
    Nenner  : ARRAY[0..kmax] OF PInfInt;
    BK,
    X,X1,
    Y,Y1,
    H1,H2,K1,K2   : PInfInt;
    N,v,k,h,r : longint;
    Ausgabefile : text;
    Nur_Bildschirm : boolean;


PROCEDURE Begruessung;
VAR ch : char;
BEGIN
  ClrScr;
  writeln;
  writeln('Bernoullische Zahlen':50);
  writeln('--------------------':50);
  writeln('Disese Programm berechnet die Bernoullischen Zahlen bis zu einem');
  writeln('maximalen Index von ',kmax,' oder weniger. Die Ausgabe erfolgt ');
  writeln('entweder nur auf den Bildschirm, oder zustzlich noch in ein ');
  writeln('Textfile mit dem Namen ''BERNZAHL.TXT'' auf dem aktuellen Laufwerk.');
  writeln;
  REPEAT
    write('Bis zu welchem Index soll gerechnet werden ? ');
    readln(N);
  UNTIL (N > 0) AND (N <= kmax);
  write('Sollen die Resultate auch auf Diskette geschrieben werden (J/N)?');
  REPEAT
    read(ch);
    ch := upcase(ch);
  UNTIL ch IN ['J','N'];
  Nur_Bildschirm := ch = 'N';
  IF NOT Nur_Bildschirm THEN
  BEGIN
    assign(Ausgabefile,'BERNZAHL.TXT');
    rewrite(Ausgabefile);
  END;
END; {Begruessung}

PROCEDURE Ausgabe(k:integer);
{Gibt die Zahl Zaehler[k]/Nenner[k] auf den Bildschirm und wenn ntig auf
 Diskette aus}
BEGIN
  {Zuerst Bildschirmausgabe}
  write('B(',k,')= '); Zaehler[k]^.Write(Output); write('/');
  Nenner[k]^.Write(OutPut); writeln;
  {dann wenn ntig auf Diskette}
  IF NOT Nur_Bildschirm THEN
  BEGIN
    write(Ausgabefile,'B(',k,')= '); Zaehler[k]^.Write(Ausgabefile);
    write(Ausgabefile,'/');
    Nenner[k]^.Write(Ausgabefile);
    writeln(Ausgabefile);
  END;
END; {Ausgabe}

PROCEDURE kuerzen(VAR X,Y:PInfInt);
VAR GGT: PInfInt;
BEGIN
  GGT := new(PInfInt,GGT(X,Y));
  dispose(X^.DivideRemainder(GGT),Done);
  dispose(Y^.DivideRemainder(GGT),Done);
  dispose(GGT,Done);
END;{kuerzen}

BEGIN {Bernoullische_Zahlen}
  Begruessung;
  Zaehler[0] := new(PInfInt,AssignLong(1));
  Nenner[0] := Zaehler[0];
  Ausgabe(0);  {1. Zahl initialisieren und ausgeben }
  v := 1;
  FOR k := 1 TO N DO
  BEGIN
    v := -v;
    X := new(PInfInt,AssignLong(k+1));
    Y := new(PInfInt,AssignLong(1));
    BK := new(PInfInt,AssignLong(1));
    FOR h := 0 TO k-1 DO
    BEGIN
      X1 := new(PInfInt,Prod(Zaehler[h],BK));
      X1^.ChangeSign;
      H1 := new(PInfInt,Prod(X,Nenner[h]));
      dispose(X,Done);
      H2 := new(PInfInt,Prod(X1,Y));
      dispose(X1,Done);
      X := new(PInfInt,Sum(H1,H2));
      dispose(H1,Done); dispose(H2,Done);
      Y^.Multiply(Nenner[h]);
      kuerzen(X,Y);
      {Binomialkoeffizient richten}
      BK^.MultiplyLong(k+1-h);
      BK^.DivideRemainderLong(h+1);
      BK^.ChangeSign;
    END;
    IF v = -1 THEN X^.ChangeSign;
    Y^.MultiplyLong(k+1);
    kuerzen(X,Y);
    Zaehler[k] := X;
    Nenner[k] := Y;
    Ausgabe(k);
    dispose(BK,Done);
  END;
  IF NOT Nur_Bildschirm THEN close(Ausgabefile);
END. {Bernoullische_Zahlen}

