/*
 *	$Header$
 *
 *	Copyright (c) Chinchilla Software Ltd, 1991-93. All rights reserved.
 *
 *	B-Tree routines.
 */
#ifndef BTREE_H
#define BTREE_H

/* The order of the Btree - an even number please */
#define BTORDPOWER 3
#define BTCHOP	(1 << BTORDPOWER)
#define BTORDER	(BTCHOP << 1)

/* The element structure describes an element in a Btree */
typedef struct btel {
  char		*key;			/* Element's key */
  void		*val;			/* Element's value */
  struct btpage	*p;			/* Pointer to successor page */
} BTEL;

/* The page structure describes a page in a Btree */
typedef struct btpage {
  short int		c;		/* Number of elements in page */
  struct btel		*e[BTORDER];	/* Array of elements */
  struct btpage		*p;		/* First successor page */
} BTPAGE;

BTEL *bt_insert	(char *key, void *val, BTPAGE **root);
BTEL *bt_search	(char *key, BTPAGE *pp);
BTEL *bt_first	(BTPAGE *pp);
BTEL *bt_last	(BTPAGE *pp);
BTEL *bt_next	(BTEL *ep, BTPAGE *pp);
BTEL *bt_prev	(BTEL *ep, BTPAGE *pp);
void bt_delete	(char *key, void *val, BTPAGE **root);
void bt_fold	(BTPAGE **pp);
void bt_pnode	(BTPAGE *pp, int level);

#endif /* !BTREE_H */
