===========================================================================
 BBS: The Abacus * HST/DS * Potterville, MI
Date: 04-07-93 (20:24)             Number: 226
From: RICH GELDREICH               Refer#: NONE
  To: QUINN TYLER JACKSON           Recvd: NO  
Subj: Comp002c.bas 1of5              Conf: (35) Quick Basi
---------------------------------------------------------------------------
'________O_/________________________| SNIP
|______________________\_O_______
'        O \                        | HERE |                      / O
'This file created by PostIt! v6.0.
'>>> Start of page 1.

DECLARE FUNCTION FunGeldComp$ (InText$, ErrorCode%)
DECLARE SUB SrgChar (BYVAL Char%)
DECLARE SUB SrgHash (InText$, BYVAL SlidePointer%, BYVAL_
 StringPointer%, BYVAL TotalBytes%)
DECLARE SUB SrgLoadHashTable ()
DECLARE SUB SrgMatch (BYVAL MatchPos%, BYVAL MatchLen%)
DECLARE SUB SrgScan (BYVAL SlidePos%, MatchPos%, MatchLen%)
DECLARE SUB SrgSearch (BYVAL SlidePointer%, BYVAL TotalBytes%)
DECLARE SUB SrgSlideDict ()
DECLARE SUB SrgWriteBits (BYVAL Bits%, BYVAL NumBits%)
DECLARE FUNCTION FunCompression% (InText$)
'COMP002C.BAS
'LZ77 sliding dictionary compressor. Revision 1.
'Public Domain By Rich Geldreich, March 1993.
'
'What the hell is LZ77?
'
'The LZ77 algorithm reduces the size  of data by replacing strings of
'characters with pointers to previously sent strings.  The  algorithm
'always  tries to find a match for a string; if no match can be found
'a single character of the string is sent uncompressed and the search
'starts over with the  next  character.   This  is done until no more
'characters remain to be compressed.  In theory the algorithm is very
'simple, but getting an implementation of it up to speed is a bit  of
'a challenge.
'
'How this program works:
'
'This  program  finds matches for upcomming text by keeping thousands
'of linked lists which contain strings  which all start with the same
'three characters(due to hashing collisions this is not true  all  of
'the  time, but the searching algorithm ignores this condition).  For
'instance, all strings which start with the characters "ABC" would be
'in the same linked list, so finding a match for any string beginning
'with "ABC" is a simple  matter  of  searching through the "ABC" list
'and comparing.  A pointer to the largest match would  then  sent  to
'the  output stream.  Since the pointer would require less space than
'the string it replaced, compression would occur.

DEFINT A-Z
CONST Version = 1
CONST True = -1, False = 0

CONST DictSize = 8192
'The ZoneSize constant must evenly divide into the DictSize constant!
CONST ZoneSize = 2048
CONST MaxTries = 100    'Affects speed vs. compression.
'The HashSize constant must be a power of two!
CONST HashSize = 2048   'Affects speed vs.  memory.
'Do not change MinMatch, because the entire program depends on it
'being three.
CONST MinMatch = 3
CONST MaxMatch = 266

TYPE BitOutputType
    ByteOffset  AS INTEGER
    BitOffset   AS INTEGER
    BitBuffer   AS LONG
END TYPE

' Sliding Dictionary
REDIM SHARED Dictionary(0)

' Hash table, each element is the "head" of its own linked list.
' Each linked lists contains strings which start with the same three
' character sequence. (Hashing collisions of course prevent this from
' being true all of the time.)
REDIM SHARED HashTable(0)

' Linked list pointers. Each element points to another element before
' it in the dictionary, or contains -1 which signals the end of the
linked
' list. To search for a match for any element in the dictionary, simply
' look up its next string and compare it. Keep on doing this until
' we find the largest match, the end of the linked list, or until we
' exaust our allowed number of searches(defined by the constant
' MaxTries).

'>>> Continued on page 2

--- MsgToss 2.0b
 * Origin: Computer Co-Op - Voorhees, NJ | Ted Hare (1:266/29)
SEEN-BY: 1/211 11/2 4 13/13 101/1 108/89 109/25 110/69 114/5 123/19 124/1
SEEN-BY: 153/752 154/40 77 157/2 159/100 125 430 575 950 203/23 209/209
SEEN-BY: 280/1 390/1 396/1 15 397/2 2230/100 3603/20
