{***************************************************************************}
{** Program : CHKSERVE                                                    **}
{***************************************************************************}
{** Version : 1.0             ** Started :           ** Ended :           **}
{***************************************************************************}
{******************************** Description ******************************}
{***************************************************************************}
{** Program to check to see if a specified server exists.                 **}
{**                                                                       **}
{**                                                                       **}
{**                                                                       **}
{**                                                                       **}
{**                                                                       **}
{**                                                                       **}
{**                                                                       **}
{***************************************************************************}
{******************************** Information ******************************}
{***************************************************************************}
{**                                                                       **}
{**                                                                       **}
{**                                                                       **}
{**                                                                       **}
{**                                                                       **}
{**                                                                       **}
{***************************************************************************}

program CHKSERVE;

uses

  nwvar,
  nwmisc
  ;

var

  MNW : MiscFuncObj;

procedure CheckCmdLine;

begin

  if paramcount < 1 then
    begin

      writeln;
      writeln ('USAGE : [servername]');
      writeln;
      halt;

    end;

end; {CheckCmdLine}

{***}

begin

  CheckCmdLine;
  MNW.Init (true);
  if MNW.FileServerExists (paramstr (1)) then
    writeln ('Server ', MNW.UppercaseNW (paramstr (1)), ' can be seen on the network.')
  else
    writeln ('Server ', MNW.UppercaseNW (paramstr (1)), ' cannot be seen on the network!');

  MNW.Done;

end.