{***************************************************************************}
{** Program : DELOBJ                                                      **}
{***************************************************************************}
{** Version : 1.0             ** Started :           ** Ended :           **}
{***************************************************************************}
{******************************** Description ******************************}
{***************************************************************************}
{** Program to delete a specified object from the bindery.                **}
{**                                                                       **}
{**                                                                       **}
{**                                                                       **}
{**                                                                       **}
{**                                                                       **}
{**                                                                       **}
{**                                                                       **}
{***************************************************************************}
{******************************** Information ******************************}
{***************************************************************************}
{**                                                                       **}
{**                                                                       **}
{**                                                                       **}
{**                                                                       **}
{**                                                                       **}
{**                                                                       **}
{***************************************************************************}

program DELOBJ;

uses

  nwvar,
  nwerror,
  nwbindry;

var

  BinderyFunc : BinderyOBJ;


procedure Initialise;

begin

  if paramcount < 2 then
    begin

      writeln;
      writeln ('USAGE : [objectname] [objecttype]');
      writeln;
      halt

    end;

  BinderyFunc.Init (true);

end; {Initialise}

{***}

procedure Done;

begin

  BinderyFunc.Done;

end; {Done}

{***}

procedure KillObject;

begin

  writeln ('Deleting bindery object : ', BinderyFunc.UppercaseNW (paramstr (1)));
  write ('Status code : ');
  with BinderyFunc do
    writeln (GetBinderyServicesError (DeleteBinderyObject (paramstr (1), StrToInt (Paramstr (2)))));

end; {KillObject}

{***}

begin

  Initialise;
  KillObject;
  Done;

end.

