UNIT getexpr;

INTERFACE

USES scanner,opcodes,table,manager;

	procedure getexp(var e:expPTR);
	procedure getexplist(var e:expPTR);

var
	parenlevel: integer;

IMPLEMENTATION

	procedure getexplist(var e:expPTR); { e+ "." e ")" -OR- e* ")" }
	{ assumes currtoken is given }
	begin {getexplist}
		e:= makepair;
		getexp(e^.car);
		nexttoken(infile);
		if currtokentype = rparen then
			begin
				dec(parenlevel);
				e^.cdr:= _nada
			end
		else if currtokentype = dot then
			begin
				nexttoken(infile);
				getexp(e^.cdr);
				nexttoken(infile);
				if currtokentype = rparen then
						dec(parenlevel)
				else
					begin
						writeln('(getexplist) missing Rparen!');
						HALT
					end
			end
		else
			getexplist(e^.cdr)
	end {getexplist} ;

	procedure getexp(var e:expPTR);
	{ assumes currtoken is given }
	begin {getexp}
		if currtokentype = alphanumeric then
			e:= makesymbol(currtoken)
		else if currtokentype = numeric then
			e:= makenumber(currtoken)
		else if currtokentype = machinecode then
			e:= makesign(currtoken)
		else if currtokentype = lparen then
			begin
				inc(parenlevel);
				nexttoken(infile);
				if currtokentype = rparen then
					begin
						dec(parenlevel);
						e:= _nada
					end
				else
					getexplist(e)
			end
		else
			begin
				writeln;
				writeln('[getexp] ord(currtokentype) = ',ord(currtokentype));
				HALT
			end
	end {getexp} ;

END.
