{ Creates a test large collection of 50,000 data objects }

PROGRAM lcTest1;  { Large Colection Test app 1 }

USES

   largeCol,
   WinCrt,
   Objects,
   WinProcs,
   WinTYpes,
   Strings;

CONST

   ListSize  = 20000;
   ListDelta = 10000;
   TestSetSize = 50000;

   Audit1 = testsetsize-999;
   Audit2 = testsetsize-990;

TYPE

   { --- Test data object --- }

   PMyTestData = ^TMyTestData;

   TMyTestData = OBJECT(TObject)
      Field1,Field2 : PChar;
      CONSTRUCTOR Init(AField1,AField2: PChar);
      DESTRUCTOR Done; VIRTUAL;
      FUNCTION GetField1 : PChar;
   END;

VAR

   AList : PLCollection;
   AFld1,AFld2 : ARRAY[0..80] OF CHAR;
   NumStr : ARRAY[0..20] OF CHAR;
   TestItem,TheItem,AnItem : PMyTestData;
   MS,ME,C,Idx  : LONGINT;
   F : TEXT;

{ ::::::::::::::::::: TMyTestData object methods ::::::::::::::::::::::: }

CONSTRUCTOR TMyTestData.Init(AField1,AField2: PChar);
BEGIN
   INHERITED Init;
   Field1 := StrNew(AField1);
   IF Field1 = NIL THEN
      MEssageBox(0,AField1,'Field 1 = nil',mb_OK);
   Field2 := StrNew(AField2);
END;

{ --------------------------------------------------------------------- }

DESTRUCTOR TMyTestData.Done;
BEGIN
   StrDispose(Field1);
   StrDispose(Field2);
END;

{ --------------------------------------------------------------------- }

FUNCTION TMyTestData.GetField1 : PChar;
BEGIN
   GetField1 := Field1;
END;

{ :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: }

BEGIN

   StrCopy(WindowTitle,'Large Collection Test 1');
   InitWinCrt;

   MS := MemAvail;
   Writeln('MemAvail = ',MS);

   AList := NEW(PLCollection,Init(ListSize,ListDelta));
   IF AList = NIL THEN
   BEGIN
      Writeln('Large collection INIT failed!');
      readln;
   END
   ELSE
   BEGIN
      FOR C := 0 TO (TestSetSize-1) DO
      BEGIN
         IF C MOD 1000 = 0 THEN
            writeln(C);
         STR(C,NumStr);
         StrCat(StrCopy(AFld1,'Item '),NumStr);
         StrCat(StrCopy(AFld2,'Data '),NumStr);
         AnItem := NEW(PMyTestData,Init(AFld1,AFld2));
         IF C = Audit1 THEN
            TestItem := AnItem;
         AList^.Insert(AnItem);
         IF AList^.Status <> lce_OK THEN
         BEGIN
            writeln('Error inserting item ',C);
            writeln('Error = ',AList^.Status);
            readln;
            halt(0);
         END
      END;
      FOR C := Audit1 TO Audit2 DO
      BEGIN
         TheItem := PMyTestData(AList^.At(C));
         IF AList^.Status <> lce_OK THEN
         BEGIN
            writeln('Error = ',AList^.Status);
            readln;
            halt(0);
         END;
         Writeln(C:5,' ',TheItem^.GetField1);
      END;
      writeln;
      Writeln('Hit any key to continue ....');
      readln;

   END;

   DISPOSE(AList,Done);

   ME := MemAvail;
   Writeln('MemAvail = ',ME);
   writeln('Diff     = ',MS-ME);

   writeln;
   Writeln('Hit any key to continue ....');
   readln;

   DoneWinCrt;

END.