{$D+} {generate debug info}
{$L+} {generate local symbol info}

{$I+} {generate code to check I/O errors}
{$Q+} {generate code to check certain integer overflows}
{$R+} {generate code to check subscript range errors}
{$S+} {generate code to anticipate stack overflow}

{$G+} {generate 80x86 instructions}

{$M 65520,0,655360} {stacksize,heapmin,heapmax}
PROGRAM main;

USES test286,
     scanner,opcodes,table,getexpr,manager,machine,analyze,putexpr,
     whatever;


const
	verbose = false;

var
	filename: string;
	arglist: expPTR;
	i: symtableindex;
	cmd: opcode;

BEGIN {main}

	putsepr('');
	putsepr('The S.E.C.D.R Machine');
	putsepr('');
	putsepr('[function to be evaluated]');
	write('Machine Code? '); readln(filename);
	if not nontrivial(filename) then HALT;
	assign(infile,filename);
	reset(infile);

	putsepr('[function]');
	parenlevel:= 0;
	noMoreInput:= false;
	nextch:= ' ';
	nexttoken(infile);
	getexp(c); writeln;
	if verbose then
		begin
			putsepr('[verbose]');
			assign(outfile,'');
			rewrite(outfile);
			putexp(c); writeln(outfile);
			close(outfile);
			putsepr('[nametable after reading fn]');
			for i:= symtablemin to nametablecount do
				if nametable[i] <> '' then writeln(nametable[i])
		end;

	putsepr('[point at which function is to be evaluated]');
	write('Argument List? '); readln(filename);
	if not nontrivial(filename) then HALT;
	assign(infile,filename);
	reset(infile);

	putsepr('[point]');
	parenlevel:= 0;
	noMoreInput:= false;
	nextch:= ' ';
	nexttoken(infile);
	getexp(arglist); writeln;
	if verbose then
		begin
			putsepr('[verbose]');
			assign(outfile,'');
			rewrite(outfile);
			putexp(arglist); writeln(outfile);
			close(outfile);
			putsepr('[nametable after reading arglist]');
			for i:= symtablemin to nametablecount do
				if nametable[i] <> '' then writeln(nametable[i])
		end;

	putsepr('[evaluate]');
	s:= makepair;
	s^.car:= arglist;
	s^.cdr:= _nada;
	e:= _nada;
	d:= _nada;
	r:= _nada;

	assign(outfile,'');
	rewrite(outfile);
	eval;
	close(outfile);

	putsepr('[result]');
	assign(outfile,'');
	rewrite(outfile);
	putexp(car(s)); writeln(outfile);
	close(outfile);

	putsepr('[save result]');
	write('Output File? '); readln(filename);
	if nontrivial(filename) then
		begin
			assign(outfile,filename);
			rewrite(outfile);
			putexp(car(s)); writeln(outfile);
			close(outfile)
		end;

	putsepr('[histogram]');
	tabulate;

	putsepr('[the end]')

END {main}.