#include "mono.h"
#pragma hdrstop

typedef unsigned char  Byte;

#define For(TheVar,TheEnd)  for(TheVar=0;TheVar<TheEnd;TheVar++)
  // Makes for a simpler, more readable, less error prone loop.
  // Use  "For(I,10)" instead of "for(I=0;I<10;I++)"

typedef struct
  {
    char Ch;
    Byte Att;
  } VideoPiece;
typedef VideoPiece ScreenLineType[80];
typedef ScreenLineType far * ScreenPtrType;
static ScreenPtrType Screen=ScreenPtrType(0xB0000000L);

static void MonoDisplay(char* Str,int X,int Y)
  {
    int StrLen=Byte(strlen(Str));
    X--;
    Y--;
    int I;
    For (I,StrLen) (Screen[Y][X+I]).Ch=Str[I];
  }

void MonoClear()
  {
    VideoPiece VP;
    VP.Ch=' ';
    VP.Att=7;
    int X,Y;
    For(Y,25)
        For(X,80) Screen[Y][X]=VP;
  }

void MonoColorLine(int Y,VideoAtt Att)
  {
    Y--;
    int I;
    For(I,80) (Screen[Y][I]).Att=Att;
  }

MonoTextWindow::MonoTextWindow(int TopY,int High)
  {
    TY=TopY-1;
    H=High;
  }

void MonoTextWindow::ScrollUp()
  {
    int YStop=TY+H-1;
    int X,Y;
    for(Y=TY;Y<YStop;Y++)
        For(X,80) Screen[Y][X]=Screen[Y+1][X];
    VideoPiece VP;
    VP.Ch=' ';
    VP.Att=7;
    For(X,80) Screen[YStop][X]=VP;
  }

void MonoTextWindow::ScrollDown()
  {
    int X,Y;
    for(Y=TY+H-2;Y>=TY;Y--)
        For(X,80) Screen[Y+1][X]=Screen[Y][X];
    VideoPiece VP;
    VP.Ch=' ';
    VP.Att=7;
    For(X,80) Screen[TY][X]=VP;
  }

void MonoTextWindow::Display(char* S, int X, int Y)
  {
    MonoDisplay(S,X,Y+TY);
  }

VideoPiece SavedScreen[25][80];

void MonoSave()
  {
    int X,Y;
    For(Y,25)
        For(X,80) SavedScreen[Y][X]=Screen[Y][X];
  }

void MonoReplace()
  {
    int X,Y;
    For(Y,25)
        For(X,80) Screen[Y][X]=SavedScreen[Y][X];
  }
