UNIT opcodes;

INTERFACE

USES table;

type
	opcode = (
		_add,
		_ap,
		_ap0,
		_bkpt,
		_car,
		_cdr,
		_caar,
		_cadr,
		_cdar,
		_cddr,
		_cadar,
		_caddr,
		_cddar,
		_cdddr,
		_cadddr,
		_cddddr,
		_cons,
		_div,
		_dum,
		_eq,
		_isatom,
		_isnada,
		_isnumber,
		_ispair,
		_issign,
		_issymbol,
		_join,
		_ld,
		_ldc,
		_lde,
		_ldf,
		_lt,
		_mul,
		_non,
		_rap,
		_rtn,
		_sel,
		_rplaca,
		_sor,
		_stop,
		_sub,
		_upd);

const
	opstrsize = 7;

var
	opstr: array[opcode] of string[opstrsize];

	function getopcode(currtoken:symtabletype):opcode;

IMPLEMENTATION

	function getopcode(currtoken:symtabletype):opcode;
	begin {getopcode}
		if currtoken = '$add' then
			getopcode:= _add
		else if currtoken = '$ap' then
			getopcode:= _ap
		else if currtoken = '$ap0' then
			getopcode:= _ap0
		else if currtoken = '$atom' then
			getopcode:= _isatom
		else if currtoken = '$bkpt' then
			getopcode:= _bkpt
		else if currtoken = '$car' then
			getopcode:= _car
		else if currtoken = '$cdr' then
			getopcode:= _cdr
		else if currtoken = '$caar' then
			getopcode:= _caar
		else if currtoken = '$cadr' then
			getopcode:= _cadr
		else if currtoken = '$cdar' then
			getopcode:= _cdar
		else if currtoken = '$cddr' then
			getopcode:= _cddr
		else if currtoken = '$cadar' then
			getopcode:= _cadar
		else if currtoken = '$caddr' then
			getopcode:= _caddr
		else if currtoken = '$cddar' then
			getopcode:= _cddar
		else if currtoken = '$cdddr' then
			getopcode:= _cdddr
		else if currtoken = '$cadddr' then
			getopcode:= _cadddr
		else if currtoken = '$cddddr' then
			getopcode:= _cddddr
		else if currtoken = '$cons' then
			getopcode:= _cons
		else if currtoken = '$div' then
			getopcode:= _div
		else if currtoken = '$dum' then
			getopcode:= _dum
		else if currtoken = '$eq' then
			getopcode:= _eq
		else if currtoken = '$join' then
			getopcode:= _join
		else if currtoken = '$ld' then
			getopcode:= _ld
		else if currtoken = '$ldc' then
			getopcode:= _ldc
		else if currtoken = '$lde' then
			getopcode:= _lde
		else if currtoken = '$ldf' then
			getopcode:= _ldf
		else if currtoken = '$lt' then
			getopcode:= _lt
		else if currtoken = '$mul' then
			getopcode:= _mul
		else if currtoken = '$nada' then
			getopcode:= _isnada
		else if currtoken = '$non' then
			getopcode:= _non
		else if currtoken = '$number' then
			getopcode:= _isnumber
		else if currtoken = '$pair' then
			getopcode:= _ispair
		else if currtoken = '$rap' then
			getopcode:= _rap
		else if currtoken = '$rplaca' then
			getopcode:= _rplaca
		else if currtoken = '$rtn' then
			getopcode:= _rtn
		else if currtoken = '$sel' then
			getopcode:= _sel
		else if currtoken = '$sign' then
			getopcode:= _issign
		else if currtoken = '$sor' then
			getopcode:= _sor
		else if currtoken = '$stop' then
			getopcode:= _stop
		else if currtoken = '$sub' then
			getopcode:= _sub
		else if currtoken = '$symbol' then
			getopcode:= _issymbol
		else if currtoken = '$upd' then
			getopcode:= _upd
		else
			begin
				writeln;
				writeln('[getopcode] invalid _sign: ',currtoken);
				HALT
			end
	end {getopcode} ;

BEGIN

opstr[_add]:=			'$add';
opstr[_ap]:=			'$ap';
opstr[_ap0]:=			'$ap0';
opstr[_bkpt]:=		'$bkpt';
opstr[_car]:=			'$car';
opstr[_cdr]:=			'$cdr';
opstr[_caar]:=		'$caar';
opstr[_cadr]:=		'$cadr';
opstr[_cdar]:=		'$cdar';
opstr[_cddr]:=		'$cddr';
opstr[_cadar]:=		'$cadar';
opstr[_caddr]:=		'$caddr';
opstr[_cddar]:=		'$cddar';
opstr[_cdddr]:=		'$cdddr';
opstr[_cadddr]:=	'$cadddr';
opstr[_cddddr]:=	'$cddddr';
opstr[_cons]:=		'$cons';
opstr[_div]:=			'$div';
opstr[_dum]:=			'$dum';
opstr[_eq]:=			'$eq';
opstr[_isatom]:=	'$atom';
opstr[_isnada]:=	'$nada';
opstr[_isnumber]:='$number';
opstr[_ispair]:=	'$pair';
opstr[_issign]:=	'$sign';
opstr[_issymbol]:='$symbol';
opstr[_join]:=		'$join';
opstr[_ld]:=			'$ld';
opstr[_ldc]:=			'$ldc';
opstr[_lde]:=			'$lde';
opstr[_ldf]:=			'$ldf';
opstr[_lt]:=			'$lt';
opstr[_mul]:=			'$mul';
opstr[_non]:=			'$non';
opstr[_rap]:=			'$rap';
opstr[_rtn]:=			'$rtn';
opstr[_rplaca]:=	'$rplaca';
opstr[_sel]:=			'$sel';
opstr[_sor]:=			'$sor';
opstr[_stop]:=		'$stop';
opstr[_sub]:=			'$sub';
opstr[_upd]:=			'$upd';

END.
