UNIT putexpr;

INTERFACE

USES manager,opcodes,table;

	procedure putexp(e:expPTR);
	procedure putexplist(e:expPTR);
	procedure putsepr(s:string);
	function nontrivial(s: string):boolean;

var
	outfile: text;

IMPLEMENTATION

	procedure putexplist(e:expPTR);
	begin {putexplist}
		putexp(car(e));
		if isnada(cdr(e)) then
			write(outfile,')')
		else if ispair(cdr(e)) then
			begin
				write(outfile,' ');
				putexplist(cdr(e))
			end
		else
			begin
				write(outfile,' . ');
				putexp(cdr(e));
				write(outfile,')')
			end
	end {putexplist} ;

	procedure putexp(e:expPTR);
	begin {putexp}
		if issymbol(e) then
			write(outfile,nametable[index(e)])
		else if isnumber(e) then
			write(outfile,value(e))
		else if issign(e) then
			write(outfile,opstr[key(e)])
		else if isnada(e) then
			write(outfile,'Nil')
		else
			begin
				write(outfile,'(');
				putexplist(e)
			end
	end {putexp} ;

	procedure putsepr(s: string);
	const
		maxcc = 79;
		whatever = '-';
	var
		i,n2: integer;
	begin {putsepr}
		n2:= ( maxcc - Length(s) ) div 2;
		for i:=1 to n2 do write(whatever);
		write(s);
		for i:=1 to n2 do write(whatever);
		if 2*n2+Length(s) < maxcc then write(whatever);
		writeln
	end {putsepr};

	function nontrivial(s: string):boolean;
	var
		i: integer;
		nonblank: boolean;
	begin {nontrivial}
		if Length(s) = 0 then
			nontrivial:= false
		else
			begin
				nonblank:= false;
				i:= 0;
				repeat
					inc(i);
					if s[i] <> ' ' then nonblank:= true
				until ( not nonblank ) or  ( i = Length(s) );
				nontrivial:= nonblank
			end
	end {nontrivial};

END.