UNIT scanner;

INTERFACE

USES table;

type
	filetype = text;
	tokentypes = (lparen,alphanumeric,numeric,machinecode,dot,rparen);

var
	infile: filetype;
	noMoreInput: boolean;
	currtoken: symtabletype;
	currtokentype: tokentypes;
	currch,nextch: char;

	procedure nexttoken(var infile: filetype);

IMPLEMENTATION

	procedure nexttoken(var infile:filetype);

		function isletter(ch:char):boolean;
		begin {isletter}
			isletter:=
								 ( ord(upcase('a')) <= ord(upcase(ch)) )
										and
								 ( ord(upcase(ch)) <= ord(upcase('z')) )
		end {isletter} ;

		function isdigit(ch:char):boolean;
		begin {isdigit}
			isdigit:=
								 ( ord(upcase('0')) <= ord(upcase(ch)) )
										and
								 ( ord(upcase(ch)) <= ord(upcase('9')) )
		end {isdigit} ;

		function isident0(ch:char):boolean;
		begin {isident0}
			isident0:= isletter(ch)
		end {isident0} ;

		function isident(ch:char):boolean;
		begin {isident}
			isident:= isletter(ch) or isdigit(ch) or ( ch in ['-','_','?','!'] )
		end {isident} ;

		function isnumeric0(ch:char):boolean;
		begin {isnumeric0}
			isnumeric0:= isdigit(ch) or ( ch = '_' )
		end {isnumeric0} ;

		function isnumeric(ch:char):boolean;
		begin {isnumeric}
			isnumeric:= isdigit(ch)
		end {isnumeric} ;

		function isspace(ch:char):boolean;
		begin {isspace}
			isspace:= ( ord(ch) <= ord(' ') )
		end {isspace} ;

		procedure getnextch;

			function lowercase(x:char):char;
			var zap: integer;
			begin {lowercase}
				zap := ord(x);
				if ( ord('A') <= zap ) and ( zap <= ord('Z') ) then
					lowercase:= char( ord('a') + ( zap - ord('A') ) )
				else
					lowercase:= x
			end {lowercase} ;

		begin {getnextch}
			read(infile,nextch);
			if eof(infile) then
				noMoreInput:= true
			else
				begin
					nextch:=lowercase(nextch);
					write(nextch)
				end
		end {getnextch} ;

	begin {nexttoken}

		currtoken:= ''; { distributes... }

		while isspace(nextch) and ( not noMoreInput ) do getnextch;
		if noMoreInput then
			begin
				writeln;
				writeln('[nexttoken] end of input!');
				HALT
			end
		else
			begin
				currch:= nextch;
				getnextch;
				if currch = '(' then
					currtokentype:= lparen
				else if currch = '$' then
					begin
						currtokentype:= machinecode;
						currtoken:= currch;
						while isident(nextch) and ( not noMoreInput ) do
							begin
								currch:= nextch;
								currtoken:= currtoken+currch;
								getnextch
							end
					end
				else if isident0(currch) then
					begin
						currtokentype:= alphanumeric;
						currtoken:= currch;
						while isident(nextch) and ( not noMoreInput ) do
							begin
								currch:= nextch;
								currtoken:= currtoken+currch;
								getnextch
							end
					end
				else if isnumeric0(currch) then
					begin
						currtokentype:= numeric;
						currtoken:= currch;
						while isnumeric(nextch) and ( not noMoreInput ) do
							begin
								currch:= nextch;
								currtoken:= currtoken+currch;
								getnextch
							end
					end
				else if currch = '.' then
					currtokentype:= dot
				else if currch = ')' then
					currtokentype:= rparen
				else
					begin
						writeln;
						writeln('[nexttoken] invalid input: ',currch,'[',ord(currch),']');
						HALT
					end
			end
		end {nexttoken} ;

END.