UNIT table;

INTERFACE

const
	symtablemin = 1;
	symtablemax = 100;

type
	symtableindex = symtablemin..symtablemax;
	symtabletype = string;
	symtable = array[symtableindex] of symtabletype;

var
	nametable: symtable;
	nametablelast: symtableindex;
	nametablecount: 0..symtablemax;

	function lookup(token:symtabletype):symtableindex;

IMPLEMENTATION

	function lookup(token:symtabletype):symtableindex;
	var
		attempt: 0..symtablemax;
		testindex:symtableindex;
		found: boolean;
	begin {lookup}
		if nametablecount = 0 then
			begin
				nametable[symtablemin]:= token;
				lookup:= symtablemin;
				inc(nametablecount)
			end
		else { nametablecount > 0 }
			begin
				found:= false;
				attempt:= 0;
				repeat
					testindex:= symtablemin+attempt;
					if token = nametable[testindex] then found:= true;
					inc(attempt)
				until
					found or ( testindex-symtablemin+1 = nametablecount );
				if found then
					lookup:= testindex
				else if nametablecount < symtablemax-symtablemin+1 then
					begin
						nametable[testindex+1]:= token;
						inc(nametablecount);
						lookup:= testindex+1
					end
				else
					begin
						writeln('nametable overflow');
						HALT
					end
			end
	end {lookup} ;

	var
		i: symtableindex;

BEGIN

	for i:= symtablemin to symtablemax do nametable[i]:= '';
	nametablecount:= 0;

END.